<template>
    <div>
        <div class="bg-white rounded p-4" v-if="currentTab === 'journals'">
            <div class="flex justify-between items-center mb-6">
                <h3 class="mb-3">List of client journals</h3>
                <button
                    @click="toggleCreateJournal"
                    class="float-right btn btn-primary"
                >
                    + New Journal
                </button>
            </div>
            <div v-if="createJournal">
                <JournalForm
                    @journal-created="handleJournalCreate"
                    :client-id="clientId"
                />
            </div>
            <template v-if="journals && journals.length > 0">
                <table>
                    <thead>
                        <tr>
                            <th>Date</th>
                            <th>Journal</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="journal in journals" :key="journal.id">
                            <td>{{ journal.date }}</td>
                            <td>{{ journal.journal }}</td>
                            <td>
                                <button
                                    class="btn btn-danger btn-sm"
                                    @click="deleteJournal(journal)"
                                >
                                    Delete
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </template>

            <template v-else>
                <p class="text-center">The client has no journals.</p>
            </template>
        </div>
    </div>
</template>

<script>
import JournalForm from './JournalForm.vue';

export default {
    name: 'JournalShow',
    components: { JournalForm },
    props: {
        clientId: {
            required: true,
        },
    },
    data() {
        return {
            journals: [],
            currentTab: 'journals',
            createJournal: false,
        };
    },
    created() {
        this.getJournals();
    },
    methods: {
        getJournals() {
            axios.get(`/clients/${this.clientId}/journals`).then((response) => {
                this.journals = response.data;
            });
        },
        deleteJournal(journal) {
            console.log(journal.id);
            axios
                .delete(`/clients/${this.clientId}/journals/${journal.id}`)
                .then(() => {
                    const journalId = this.journals.findIndex(
                        (item) => item.id === journal.id
                    );
                    this.journals.splice(journalId, 1);
                });
        },
        toggleCreateJournal() {
            this.createJournal = !this.createJournal;
        },
        handleJournalCreate(journal) {
            this.journals.push(journal);
            this.createJournal = false;
        },
    },
};
</script>
